proc LoadLibraryTdbcMysql { dir basename } {
    package require Tcl 8.6   
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	set library ${basename}115t_${bits}[info sharedlibextension]	   
    } else {
	set library lib${basename}1.1.5[info sharedlibextension]	 
    }
    source [file join $dir tdbcmysql.tcl]
    load [file join $dir $library] $basename  
}

package ifneeded tdbc::mysql 1.1.5 [list LoadLibraryTdbcMysql $dir tdbcmysql]
