
proc LoadLibrary_tclcompiler { dir basename } {
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set pref ""
    if { $::tcl_platform(platform) == "unix"} {
	set pref "lib"
    }
    set library ${pref}${basename}_${bits}[info sharedlibextension]
    load [file join $dir $library] $basename
    #load {C:\gid project\gidvs\x64\Debug\tclcompiler.dll}
}

package ifneeded tclcompiler 1.7.1 [list LoadLibrary_tclcompiler $dir tclcompiler]