
proc LoadLibrary_tclx { dir basename } {
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set pref ""
    if { $::tcl_platform(platform) == "unix"} {
	set pref "lib"
    }
    set library ${pref}${basename}_${bits}[info sharedlibextension]
    set ::env(TCLX_LIBRARY) $dir
    load [file join $dir $library] $basename
    # load {C:\gid project\gidvs\x32\Debug\tclx.dll}
}

package ifneeded Tclx 8.6 [list LoadLibrary_tclx $dir Tclx]
