### W "WEDDAVTEST [ package require vfs]"
### W "WEDDAVTEST [ package require vfs::webdav]"
### cd /tmp
### W "WEDDAVTEST pwd = [ pwd]"
### # file mkdir local
### # W "WEDDAVTEST mount = [ vfs::webdav::Mount http://username:xxx@147.83.143.171/remote.php/webdav/ local]"
### # W "WEDDAVTEST cd local"
### # cd local
### W "WEDDAVTEST file(s) = [ glob -directory local *]"
### # W "WEDDAVTEST cd .."
### # cd ..
### # W "WEDDAVTEST umount = [ vfs::webdav::Unmount http://username:xxx@147.83.143.171/remote.php/webdav/ local]"

# redefine proc to debug

# WV ::gid_start_mode

namespace eval webdav_test {
}

proc webdav_test::test {} {
    package require vfs
    package require vfs::webdav

    proc ::gid_filesystem::print_debug { txt} {
        # W "gid_filesystem::print - $txt"
    }

    proc ::vfs::log { txt} {
        # W "--log-- $txt"
    }

    # set host b2drop.bsc.es
    # set user miguel@cimne.upc.edu
    # set password secreto
    set destination_mount [ file join $::env(HOME) GiD-Cloud]
    W "set ::GiDPriv(CloudFolder) $destination_mount"
    # source {C:/temp/test_webdav/webdav-0.2.tcl}
    # cd {C:/temp/test_webdav}
    # cd /tmp
    #file mkdir {C:/temp/test_webdav/local}
    # if { ![ file exists $destination_mount] } {
    #     W "creating $destination_mount = [ file mkdir $destination_mount]"
    #     file attributes $destination_mount -hidden 0 -readonly 0
    # } else {
    #     W "$destination_mount already exists. is directory = [ file isdirectory $destination_mount]"
    # }
    # vfs::webdav::Mount http://${user}:${password}@${host}/remote.php/webdav/ $destination_mount
    # remote.php/webdav seems to be the old way to get to webdav files of user
    # remote.php/dav --> will access users calendars & other apps.
    # remote.php/dav/files/${user_folder}/ will access user files.
    # package require percentencoding
    # set user_folder [ percentencoding::encode ${user}]
    # vfs::webdav::Mount http://${user}:${password}@${host}/remote.php/dav/files/${user_folder}/ $destination_mount
    vfs::webdav::Mount [ GidDataManager::getUserWebDavPath] $destination_mount
    #cd {C:/temp/test_webdav/local}
    # if { [catch { cd local } msg] } {
    #     set kk 1
    # }

    # when quiting gid, unmount device
    GiD_RegisterEvent GiD_Event_BeforeExit webdav_test::end

    # the rest
    set result [glob -directory $destination_mount *]
    puts $result
    # vfs::webdav::Unmount http://${user}:${password}@${host}/remote.php/webdav/ $destination_mount
    return $result
}

# test2 with twapi (not related to vfs at all)
proc webdav_test::test2 {} {
    if { $::tcl_platform(platform) == "windows" } {        
        package require twapi
        package require twapi_share
        package require percentencoding

        set user_folder [ percentencoding::encode ${user}]
        # net use x: needs /remote.php/dav/... and not /remote.php/webdav/....
        set unit [ twapi::connect_share [ GidDataManager::getWebDavPath] \
            -user [ GidDataManager::getUsername] -password [ GidDataManager::getUserpass ] \
            -localdevice * ]
        set ::GiDPriv(CloudUnit) $unit

        # when quiting gid, unmount device
        GiD_RegisterEvent GiD_Event_BeforeExit webdav_test::end

        # the test
        set result [glob -directory $unit *]
        # puts $result
        return $result
    }
}

proc webdav_test::end {} {
    if { [ info exists ::GiDPriv(CloudFolder)] && ( $::GiDPriv(CloudFolder) != "")} {
        vfs::webdav::Unmount dummy $::GiDPriv(CloudFolder)
        unset ::GiDPriv(CloudFolder)
    }
    if { [ info exists ::GiDPriv(CloudUnit)] && ( $::GiDPriv(CloudUnit) != "") } {
        twapi::disconnect_share $::GiDPriv(CloudUnit)
        unset ::GiDPriv(CloudUnit)
    }
}

set result [ webdav_test::test]
WV result

# W ----------------------------------
# W [ gid_filesystem::glob -directory $::GiDPriv(CloudFolder) * ]
# W ----------------------------------
# W [ gid_filesystem::glob -directory $::GiDPriv(CloudFolder) -type f * ]
# W ----------------------------------
# W [ gid_filesystem::glob -directory $::GiDPriv(CloudFolder) -type d * ]
# W ----------------------------------
# W [ gid_filesystem::file attributes $::GiDPriv(CloudFolder)]
# W ----------------------------------
# W [ gid_filesystem::file attributes $::GiDPriv(CloudFolder)/test_kratos_fluid3D_zoom_render_smooth_2_amd.png]
# W ----------------------------------
# W [ gid_filesystem::glob -nocomplain -type {hidden d} -directory $::env(HOME) *]
# W ----------------------------------
# W [ gid_filesystem::glob -nocomplain -type {hidden f} -directory $::GiDPriv(CloudFolder) *]
# W ----------------------------------
# W ----------------------------------
# W [ gid_filesystem::glob -nocomplain -type f -directory $::GiDPriv(CloudFolder) *]
# W ----------------------------------
