package require gid_wizard

gid_wizard::wizardstep step1\
    -title "The first step in the process"\
    -subtitle "Or what you will..."\
    -pretext "Please fill in the following form"\
    -posttext "Thank you for doing that"\
    -body {
	set can [canvas $win.canvas -background red]
	
	pack $can -fill both -expand 1
	#[winfo parent [winfo parent [winfo parent $win]]] buttonstate finish disabled
    }

gid_wizard::wizardstep step2  -title "Step2" -layout basic -body {
    
    set can [canvas $win.canvas -background blue]
    
    pack $can -fill both -expand 1
    #[winfo parent [winfo parent [winfo parent $win]]] buttonstate finish normal
}

gid_wizard::wizardstep step3  -title "Final Step" -layout basic -body {
    
    set lab [label $win.l -text "Enter Your name"]
    set ent [entry $win.e]
    
    grid $lab $ent
    #[winfo parent [winfo parent [winfo parent $win]]] enable step2
}

toplevel .gid.wizard
gid_wizard::wizard .gid.wizard.my_wizard -steps {step1 step2 step3}
.gid.wizard.my_wizard start
bind .gid.wizard.my_wizard <<WizNext>> [list W "next step=%d"]
bind .gid.wizard.my_wizard <<WizPrev>> [list W "prev step=%d"]
bind .gid.wizard.my_wizard <<WizFinish>> [ list W "finish" ]
