#
# Tcl package index file
#

proc LoadLibraryHdf5 { dir basename } {
    package require objarray
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set library ${basename}_${bits}[info sharedlibextension]    
    load [file join $dir $library] $basename
    #load "C:/gid project/gidvs/x${bits}/Debug/hdf5tcl.dll"
}

package ifneeded hdf5 1.11 [list LoadLibraryHdf5 $dir hdf5tcl]
