#
# Tcl package index file
#

proc LoadLibrary_netcdf { dir basename } {
    if { $::tcl_platform(pointerSize) == 8} {
        set bits 64
    } else {
        set bits 32
    }
    set pref ""
    if { $::tcl_platform(platform) == "unix"} {
        set pref "lib"
    }
    set debug ""
    set library ${pref}${basename}_${bits}${debug}[info sharedlibextension]
    load [file join $dir $library] $basename
}

package ifneeded netcdf 1.0 [list LoadLibrary_netcdf $dir netcdf]
