
# example:
# set oa1 [ objarray new_from_to intarray 2 5]
# set oa2 [ objarray new_from_to intarray 6 9]
# W [ objarray_map floatarray {{x y} {expr $x + $y}} [ list $oa1 $oa2]]

proc objarray_map { dst_oa_type lambda lst_arrays } {
    set n_items [ objarray length [ lindex $lst_arrays 0]]
    set new_obj [ objarray new $dst_oa_type $n_items]
    for { set i 0} { $i < $n_items} { incr i} {
        set lst_args {}
        foreach ar $lst_arrays {
            lappend lst_args [ objarray get $ar $i]
        }
        objarray set $new_obj $i [ apply $lambda {*}$lst_args]
    }
    return $new_obj
}

