set ::env(ITCL_LIBRARY) $dir
# -*- tcl -*-
# Tcl package index file, version 1.1
#

if {![package vsatisfies [package provide Tcl] 8.6-]} {return}

proc LoadLibraryItcl { dir basename } {       
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	set library ${basename}423t_${bits}[info sharedlibextension]	   
    } else {
	# set library lib${basename}4.2.3[info sharedlibextension]
	set library libitcl4.2.3[info sharedlibextension]
    }
    load [file join $dir $library] $basename    
}

package ifneeded itcl 4.2.3 [list LoadLibraryItcl $dir Itcl]
package ifneeded Itcl 4.2.3 [list package require -exact itcl 4.2.3] ;#old name
