proc LoadLibraryRegistry { dir basename } {   
    package require Tcl 8.4  
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	set library tclreg13_${bits}[info sharedlibextension]   
    }
    load [file join $dir $library] $basename    
}

package ifneeded registry 1.3.5 [list LoadLibraryRegistry $dir registry]
