proc LoadLibrarySqlite3 { dir basename } {       
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	set library ${basename}400t_${bits}[info sharedlibextension]	   
    } else {
	set library lib${basename}.40.0[info sharedlibextension]	 
    }
    load [file join $dir $library] $basename
}

package ifneeded sqlite3 3.40.0 [list LoadLibrarySqlite3 $dir sqlite3]

