proc LoadLibraryTdbc { dir basename } {
    package require TclOO
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	set library ${basename}115t_${bits}[info sharedlibextension]	   
    } else {
	set library lib${basename}1.1.5[info sharedlibextension]	 
    }
    load [file join $dir $library] $basename
    source [file join $dir tdbc.tcl]
}

package ifneeded tdbc 1.1.5 [list LoadLibraryTdbc $dir tdbc]
