proc LoadLibrary_tksvg { dir basename } {
    package require Tk
    if { $::tcl_platform(pointerSize) == 8} {
	    set bits 64
    } else {
	    set bits 32
    }
    set pref ""
    if { $::tcl_platform(platform) == "unix"} {
	    set pref "lib"
    }
    set library ${pref}${basename}_${bits}[info sharedlibextension]
    load [file join $dir $library] $basename  
    #load {C:\gid project\gidvs\x32\Debug\tksvg.dll} tksvg
}

package ifneeded tksvg 0.14 [list LoadLibrary_tksvg $dir tksvg]
