#
# Tcl package index file
#

proc LoadLibraryVtk_objarray { dir basename } {
    package require objarray
    package require vtk
    if { $::tcl_platform(pointerSize) == 8} {
	set bits 64
    } else {
	set bits 32
    }
    set library ${basename}_${bits}[info sharedlibextension]    
    load [file join $dir $library] $basename
    #load {C:\gid project\gidvs\Debug\vtk_objarray.dll}
}

package ifneeded vtk_objarray 1.1 [list LoadLibraryVtk_objarray $dir vtk_objarray]
